%%%%%%%%% Instantaneous mixing data;c
clear
close all
rng(2017);
T_orig = h5read('dNTF/contamination/tensor.jld', '/T');

%%% CP decomposition
CP_dec = sptensor(T_orig);
C      = cp_als(CP_dec, 5);
N      = cp_nmu(CP_dec, 5);
%%% Tucker 3 decomposition
T      = tucker_als(CP_dec, [5, 2, 3]);

TC = double(C);
TN = double(N);
TT = double(T);

figure()
suptitle('Original');
subplot(1,10,1)
image(T_orig(:,:,1))
title('t_1')
subplot(1,10,2)
image(T_orig(:,:,2))
title('t_2')
subplot(1,10,3)
image(T_orig(:,:,3))
title('t_3')
subplot(1,10,4)
image(T_orig(:,:,4))
title('t_4')
subplot(1,10,5)
image(T_orig(:,:,5))
title('t_5')
subplot(1,10,5)
image(T_orig(:,:,5))
title('t_5')
subplot(1,10,6)
image(T_orig(:,:,6))
title('t_6')
subplot(1,10,7)
image(T_orig(:,:,7))
title('t_7')
subplot(1,10,8)
image(T_orig(:,:,8))
title('t_8')
subplot(1,10,9)
image(T_orig(:,:,9))
title('t_9')
subplot(1,10,10)
image(T_orig(:,:,10))
title('t_10')

figure()
suptitle('NCP');
subplot(1,10,1)
image(TN(:,:,1))
title('t_1')
subplot(1,10,2)
image(TN(:,:,2))
title('t_2')
subplot(1,10,3)
image(TN(:,:,3))
title('t_3')
subplot(1,10,4)
image(TN(:,:,4))
title('t_4')
subplot(1,10,5)
image(TN(:,:,5))
title('t_5')
subplot(1,10,5)
image(TN(:,:,5))
title('t_5')
subplot(1,10,6)
image(TN(:,:,6))
title('t_6')
subplot(1,10,7)
image(TN(:,:,7))
title('t_7')
subplot(1,10,8)
image(TN(:,:,8))
title('t_8')
subplot(1,10,9)
image(TN(:,:,9))
title('t_9')
subplot(1,10,10)
image(TN(:,:,10))
title('t_10')

figure()
suptitle('CP');
subplot(1,10,1)
image(TC(:,:,1))
title('t_1')
subplot(1,10,2)
image(TC(:,:,2))
title('t_2')
subplot(1,10,3)
image(TC(:,:,3))
title('t_3')
subplot(1,10,4)
image(TC(:,:,4))
title('t_4')
subplot(1,10,5)
image(TC(:,:,5))
title('t_5')
subplot(1,10,5)
image(TC(:,:,5))
title('t_5')
subplot(1,10,6)
image(TC(:,:,6))
title('t_6')
subplot(1,10,7)
image(TC(:,:,7))
title('t_7')
subplot(1,10,8)
image(TC(:,:,8))
title('t_8')
subplot(1,10,9)
image(TC(:,:,9))
title('t_9')
subplot(1,10,10)
image(TC(:,:,10))
title('t_10')

figure()
suptitle('Tucker');
subplot(1,10,1)
image(TT(:,:,1))
title('t_1')
subplot(1,10,2)
image(TT(:,:,2))
title('t_2')
subplot(1,10,3)
image(TT(:,:,3))
title('t_3')
subplot(1,10,4)
image(TT(:,:,4))
title('t_4')
subplot(1,10,5)
image(TT(:,:,5))
title('t_5')
subplot(1,10,5)
image(TT(:,:,5))
title('t_5')
subplot(1,10,6)
image(TT(:,:,6))
title('t_6')
subplot(1,10,7)
image(TT(:,:,7))
title('t_7')
subplot(1,10,8)
image(TT(:,:,8))
title('t_8')
subplot(1,10,9)
image(TT(:,:,9))
title('t_9')
subplot(1,10,10)
image(TT(:,:,10))
title('t_10')